#!/usr/bin/env bash

source "$(dirname ${BASH_SOURCE[0]})/vars.sh"

goal app call \
    --app-id 1 \
    -f "$ONE" \
    --app-arg "str:run" \
    --app-arg "int:$ITR" \
    -o call-main.tx


for (( i=1 ; i<$NTXN ; i++ ));
do
    goal app call \
        --app-id 1 \
        -f "$ONE" \
        --app-arg "str:run" \
        --app-arg "int:0" \
        -o call-"$i".tx
    
    echo "Txn ${i} added"
    cat call-"$i".tx >> call-main.tx

done


goal clerk group -i call-main.tx -o grouped.tx
goal clerk split -i grouped.tx -o split.tx

for (( i=0 ; i<$NTXN ; i++ ));
do 
    echo $i
    goal clerk sign -i split-"$i".tx -o signed-"$i".tx
done
    
for (( i=1 ; i<$NTXN ; i++ ));
do
    cat signed-"$i".tx >> signed-0.tx
done

goal clerk rawsend -f signed-0.tx